% Script file: TORSCONMUdata.m
%
%    This M-file prapares the data for the program TORSCON   
%    Example 6.3
clear all;
fprintf('********* PLDATA ********** \n');
inputfile1=input('Enter file name :','s');
fid = fopen (inputfile1,'w');
user=input('User name:','s');
title=input('Title:','s');
%==========================================================================
% BOUNDARY DATA
%==========================================================================
nb=2;                   % number of boundaries
                             %
ns=16;                   % number of sides.
                            % A side is defined as a part of the boundary  
                            % between the corner points. Points where
                            % the boundary conditions change or points 
                            % of point supports treated as corner points.
                            % Parts of the boundary with different geometry
                            % are different sides.

% Give the side properties
%ATENSION: External boundaries are run  anticlockwise,
%          internal boundaries clockwise. 

%---------------------------------ms-----------------------------------------------          
%               1       2             3   4       5         6         7                 8        
%------------------------------------------------------------------------------------                       
%line      : 1 | No of BE | x1 | y1  |   x2   |  y2   | unused   |  unused  |    
%            
%circle   : 2 | No of BE | x0 | y0  | phi1 | phi2 | radious   | unused   | 
%          
%ellipse:  3 | No of BE | x0 | y0  | phi1 | ph2  | radious1 | radious2|            
%---------------------------------------------------------                                                              
% Give: 1 for straight line; 2 for circular arc
% x1               : x coordinate  of the starting point
% y1               : y coordinate  of the starting point
% x2               : x coordinate  of the end point
% y2               : y coordinate  of the end point

% x0               : x coordinate  of the center 
% y0               : y coordinate  of the center
% phi1, phi2       : limit angles of the circular arc
% radious1 : lenght of semiaxis 1
% radious2 : lenght of semiaxis 2
% 
% ms:= array including the side properteis
ms=zeros(ns,7);
ms=[ 1 ,120 ,-3,0,3,0 , 0 , 0  ;
         1 ,50  ,3,0,3,2.5 , 0 , 0;
        1 , 40 ,3,2.5,5,2.7 , 0 , 0;
        1 , 6 ,5,2.7,5,3 , 0 , 0;
        1 ,200  ,5,3,-5,3 , 0 , 0;
        1 , 6 ,-5,3,-5,2.7 , 0 , 0;
        1 , 40 ,-5,2.7,-3,2.5 , 0 , 0;
        1 , 50 ,-3,2.5,-3,0 , 0 , 0;
        1 , 18 ,-1.6,0.5,-2,0.75 , 0 , 0;
        1 , 68 ,-2,0.75,-2,2.25 , 0 , 0;
        1 , 18 , -2,2.25,-1.6,2.5, 0 , 0;
        1 ,124  ,-1.6,2.5,1.6,2.5 , 0 , 0;
        1 , 18 ,1.6,2.5,2,2.25 , 0 , 0;
        1 , 68 , 2,2.25,2,0.75, 0 , 0;
        1 , 18 , 2,0.75,1.6,0.5, 0 , 0;
        1 , 124 ,1.6,0.5,-1.6,0.5 , 0 , 0    ];
%       
%  CALL function: boundarypoints
%                For the meanning of the output parameters see function
%                boundarypoints.m
nl=zeros(nb,1);
nl=[512;968];               % serial number of the last element of each boundary

[nbe,xb,yb,xl,yl,jn,kn,angle,cn,sn,length,cur]=boundarypoints(ms,ns,nl);

%==========================================================================  
% GENERATION of the coorinates of the domain mesh points xin,yin where the
% solution and its derivatives  will be evaluated.
% A rectangular mesh with nrow X ncol nodal points is applied on the domain
% Then the function checkin.m detects the nodal points
% inside the domain. The function checkdist detects interior nodal points 
% at distance from the boundary smaller than a minimum prescribed distance 
% and excludes them.
%==========================================================================

nrow=40;
ncol=40;
inpoint=nrow*ncol;
ax=max(xb)-min(xb);
by=max(yb)-min(yb);
dxin=ax/(ncol+1);
dyin=by/(nrow+1);
nrow1=nrow;
ncol1=ncol;
mt=nrow1*ncol1;       
xint=zeros(1,mt);
yint=zeros(1,mt);

for i=1:nrow1
    for j=1:ncol1
        k=(i-1)*ncol1+j;
       xint(k)=min(xb)+j*dxin;
       yint(k)=min(yb)+i*dyin;
    end
end
%==========================================================================
% CALL function checkin.m to detect points inside the domain of the plate
%==========================================================================
dist=0.02;  %the minimum distance of the internal points from the boundary
[m,xin,yin]=checkin(nbe,mt,xb,yb,xint,yint,cn,sn,length,dist);
          % m  = final total number of mesh point points

%==========================================================================
fprintf(' No of boudary elements \n');
nbe
fprintf(' No of internal  points \n');
m
%==========================================================================
% PLOT DATA
plot(xl,yl,'m+',xb,yb,'b.',xin,yin,'r.');  
%==========================================================================
% WRITE data in the inputfile
%==========================================================================
fprintf(fid,user );
fprintf(fid,'\n');
fprintf(fid,title );
fprintf(fid,'\n');
for ii=1:nb
    fprintf(fid,'%6.0f \n',nl(ii));
end
for ii=1:nbe
    fprintf(fid,'%6.8f %6.8f %0.0f\n',xl(ii),yl(ii),angle(ii));
end
for ii=1:m
    fprintf(fid,'%5.5f %5.5f \n',xin(ii),yin(ii));
end

fclose(fid);

